/*************************************************************************
Hs external xital 20Mhz PLL div 5
pic version:18F2550
pin out:
UART RC7 ---> RX          (Default pin18)
UART RC8 ---> TX          (default pin17)
I2C RB0 ----> SDA         (default pin21)  PT2257 Volume CTRL addr:88
I2C RB1 ----> SCL         (default pin22)  PT2257 Volume CTRL addr:88
RB3 ----> TD (Rotary Encoder)
RB4 ----> CLK (Rotary Encoder)
RB5 ----> SELECTION_SW1 (Rotary Encoder)

the comunication between PC and MCU-USART is making whit Bluetooth module
The volume amplitude is changed turn on the left and right one rotary Encoder
If you push the rotary encoder axis you'll turn on and turn off mute.

IMPORTANT:
In this code I introduced the Priority system to give to threads them
different priority , this is possible using timer 2 as engine of all 
synchronized system. in this mode will be possible write  complicated and long 
threads e reactive. The MCU it'll be seems more reactive to commands.
loop10ms % 1 ---> high priority.
loop10ms % 2 ---> medium-high priority.
loop10ms % 3 ---> medium priority.
loop10ms % 4 ---> medium-low priority.
loop10ms % 5 ---> low priority.


Timer2
Prescaler 1:4; Postscaler 1:5; TMR2 Preload = 250;
Actual Interrupt Time : 1,001 ms

This Library work for MikroC ver.7.2 (not minor version)

< WROTE BY LEO M. >
*************************************************************************/
#include <stdbool.h>
#include"PT2257_Volume_CTRL\PT2257_Vol_CTRL__Lib_v1_0.h"

#define BACK 8
#define CLS 12
#define TAB 9

// === ROTATORY ENCOODER CONNECTIONS ====

sbit TD at RB3_bit  ;
sbit CLK at RB4_bit ;
sbit SELECTION_SW1 at RB5_bit ;

sbit TD_Direction at TRISB3_bit  ;
sbit CLK_Direction at TRISB4_bit ;
sbit SELECTION_SW1_Direction at TRISB5_bit ;

// == END ROTATORY ENCOODER CONNECTIONS ==

unsigned char intcount=0;
unsigned char loop10ms=0;
unsigned char sec=0;

// PROTOTIPE DEFINITION
void Hardware_Init(void);
void Interrupt(void);
void InitTimer0(void);
void InitTimer2(void);


void Interrupt() iv 0x0008 ics ICS_AUTO {

  if (TMR2IF_bit){
    intcount++;
    if(intcount >= 100){ // enter here every 10mS
      intcount=0;
      
      loop10ms++; //IMPORTANT VARIABLE BECAUSE MANAGE THREADS PRIORITY IN MAIN
      if(loop10ms >= 10)  // ENTER HERE EVERY 1 SEC
       {
        //PORTA.B3 = ~PORTA.B3;  // LED BLINK EVERY SECOND
        loop10ms=0;
        sec++;
        }
     }
    TMR2IF_bit = 0;
    //Enter your code here
  } // END TIMER 2 INT

} // END INTERRUPT FUNCTIONS

void InitTimer2(){
  T2CON	 = 0x25;
  TMR2IE_bit	 = 1;
  PR2		 = 250;
  INTCON	 = 0xC0;
}

void InitHardware() {
  TRISA = 0b00000011 ;   // =0 OUTPUT or PORTA = 0x00;
  TRISB = 0b00111100;   // set B5,B4,B3,B0 as input,other as Output
  TRISC = 0;
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1
  PORTA=0;           // off all Port A pins
  PORTB=0;           // off all Port B pins
  //PORTC=0;         // off all Port C pins
  //TRISC = 0x80;    //   RC7 = RX UART
  LATC=0x00;         // off all Port C pins
  CMCON = 0x07;      // Disable comparators
  ADCON0=0x00;       // Disable all Analogical/Digital Converters
  ADCON1=0b00001111; // Disable Analog functions Configure AN pins as digital
  I2C1_Init(400000);
 }

void main() {
unsigned char Vol;

InitHardware();

UART1_Init(9600);
Delay_ms(100);
UART1_Write(CLS);// Erase screen terminal,it is an option on Vbray Terminal!
PT2257_Init();
Delay_ms(100);


Vol=40;
// INTRODUCTION
UART1_Write_Text(" TEST PT2257 12C DEVICE VOLUME CONTROL \r\n");
UART1_Write_Text(" MCU 18F2550 EXT.XITAL 20MHZ PLL/5 \r\n");
UART1_Write_Text("\r\n");
// END INTRODUCTION
    
writeVolume(Vol); // Initialization Volume level
serialPrintStateJSON(); // print Volume and Mute status
InitTimer2();

 do{
   // THREAD 1 HIGH PRIORYTY
   if((loop10ms % 1) == 0) {
     if( (CLK == 0) && (TD==0) ) {  // IF YOU TURN ON THE LEFT SIDE
      if(Vol>0) {
      Vol-- ; writeVolume((int)Vol);
      serialPrintStateJSON();
      while(CLK==0);//removes disturbances in the phase of the rotary transition
      }
     }

     if( (CLK == 0) && (TD==1) ){  // IF YOU TURN ON THE LEFT SIDE
      if(Vol<79) {
      Vol++  ; writeVolume((int)Vol);
      serialPrintStateJSON();
      while(CLK==0);//removes disturbances in the phase of the rotary transition
      }
     }
     if(SELECTION_SW1==0) {
      while(SELECTION_SW1==0);
       toggleMute();
       serialPrintStateJSON();
      }
    } // END THREAD 1
   
   // THREAD 2 LOW PRIORITY
   if((loop10ms % 5) == 2) {
     // does something
    
    } // END THREAD 2
   
   // THREAD 3 MEDIUM PRIORITY
   if((loop10ms % 3) == 3) {
     // does something
    
    } // END THREAD 3
   
   // YOU CAN CONTINUE TO INSERT THREADS UNTIL 255 THREADS
 
 }while(1);
}   // end main











// === ROTATORY ENCOODER CONNECTIONS ====
/*
sbit CLK at RB0_bit ;
sbit TD at RB1_bit  ;
sbit SELECTION_SW at RA1_bit ;

sbit CLK_Direction at TRISB0_bit ;
sbit TD_Direction at TRISB1_bit  ;
sbit SELECTION_SW_Direction at TRISA1_bit ;
*/
// == END ROTATORY ENCOODER CONNECTIONS ==
//INTCON.INT0IE = 1 ;                   // enable RB0 pin Interrupt
//INTCON.GIE = 1 ;                      // enable all interrupt
/**
void Interrupt(){
if (INTCON.INT0IF==1){       //Test if RB0 received Interrupt Signal
       //IF YOU TURN ON THE LEFT SIDE
       LED_TEST = 1 ;
       PWM1_Stop() ;
       if(CLK == TD) {
        // your code
        PR2-- ;
        }
       // IF YOU TURN ON THE RIGHT SIDE
       if(CLK != TD) {
        // Your Code
        PR2++  ;
        }
       Frequency_Changed = 1 ;
       LED_TEST = 0 ;
       PWM1_Start() ;
       INTCON.INT0IF = 0 ;                  // Turn off Interrupt Flag on RB0

    }
} // END INTERRUPT FUNCTION
**/
//#define CR 0x0D
//#define LF 10
//#define TAB 9
//#define BACK 8
//TRISC.TRISC7 = 1;  // RX - UART1
//  TRISC.TRISC6 = 0;  // TX - UART1
//TRISD.TRISD0 = 0;  // SCL I2C2
//TRISC.TRISD1 = 1;  // SDA I2C2
//Delay_us(10); between I2C instructions
//SLRCON=0; // standard rate for PORTA,B,C,D,E
//UART1_Write(CLS);
// My_CRLF();
// unsigned char CRam1[6];
// IntToStr(Ratio,CRam1); //ratio is short
// My_UART1_Write_Text(CRam1); +it redled at PORTA.B1;
//My_UART1_Write_CText("HELLO \r\n");
//sbit greenled at PORTA.B2;
//sbit blueled at PORTA.B3;
// PIN DIRECTIONS
//sbit redled_Direction at TRISA1_bit;
//sbit greenled_Direction at TRISA2_bit;
//sbit blueled_Direction at TRISA3_bit;
//PORTA.B2=1;
     //Delay_ms(500);
     //PORTA.B2=0;
     //Delay_ms(500);
    // UART1_Write_CText("   EA0= ");
   //UART1_Write_Text(CRam1);
   //UART1_Write(TAB);
   //My_UART1_Write_Text(AMP_TEXT CRam1); My_UART1_Write_CText("\r\n");
 //_asm nop;
// IntToStr(getVolume(), CRam1);
// My_UART1_Write(CRam1);
// Delay_ms(2000);
//const char MESSAGE1[]=" TEST PT2257 12C DEVICE VOLUME CONTROL";
//const char MESSAGE2[]=" MCU 18F2550 EXT.XITAL 20MHZ PLL/5";